##
## Zap-History Browser
## by AliAbdul
## based on ritzMo's idea
##
from Components.ActionMap import ActionMap
from Components.MenuList import MenuList
from enigma import eServiceCenter
from Plugins.Plugin import PluginDescriptor
from Screens.Screen import Screen

################################################

class ZapHistoryBrowser(Screen):
	skin = """
	<screen position="150,100" size="420,400" title="Zap-History Browser" >
		<widget name="list" position="0,0" size="420,400" scrollbarMode="showOnDemand" />
	</screen>"""

	def __init__(self, session, servicelist):
		Screen.__init__(self, session)
		self.servicelist = servicelist
		serviceHandler = eServiceCenter.getInstance()
		
		list = []
		for x in self.servicelist.history:
			info = serviceHandler.info(x[2])
			list.append(info and info.getName(x[2]))
		self["list"] = MenuList(list)
		
		self["actions"] = ActionMap(["OkCancelActions"], {"ok": self.zap, "cancel": self.close}, prio=-1)

	def zap(self):
		try:
			self.servicelist.history_pos = self["list"].getSelectionIndex()
			self.servicelist.setHistoryPath()
		except:
			pass

################################################

def main(session, servicelist, **kwargs):
	session.open(ZapHistoryBrowser, servicelist)

def Plugins(**kwargs):
	return PluginDescriptor(name=_("Zap-History Browser"), where=PluginDescriptor.WHERE_EXTENSIONSMENU, fnc=main)
